#ifndef SOUNDCONTROL_CLASS_H
#define SOUNDCONTROL_CLASS_H

#include "stdincl.h"
#include <SDL/SDL_mixer.h>

class SoundControl {
 public:
  ~SoundControl();

  static SoundControl* getInstance();
  
  void setNumberOfChannels(int number_of_channels);
  static void playMod(char* filename);
  static void playWav(char* filename);
  static void playOgg(char* filename);
  void volumeUp();
  void volumeDown();
  void trackRewind();
  void forwardMusic();
  void rewindMusic();
  void pauseMusic();
  void resumeMusic();
  void fadeInMusic(int time);
  void fadeOutMusic(int time);
  static void musicDone();
  
  static void handleKey(SDL_KeyboardEvent key); 
  int main(int argc, char* argv[]);
  

 private:
  SoundControl();
  void init(void);

  static SoundControl* singletonRef;

  bool isInit;

 public:

  Mix_Music* music;
  static SoundControl* sound;
  int bits;
  int volume;

  int track_number;
  int audio_rate;
  int audio_channels;
  int audio_buffers;
  int done;
  int sfx_channel1;
  int sfx_channel2;
  int finished;

  Uint16 audio_format;
};

#endif
